/**
 * 
 * scaffolding Controller
 * 
 * Beispiel CLI Aufruf:
 * 
 *    $groovy CreateController.groovy -n Person -a projektantraege --pfad=rahmenprogramm -f
 * 
 * Autor:   W.Nagy
 * Datum:   11.07.2008
 */

File currentDir = new File (".")
String rootpath = currentDir.getCanonicalPath()
String cpath = '' // controllerfad

def cli = new CliBuilder(usage: 'groovy CreateController -a "app" -p "Pfad in MVC" -n "name" ')

cli.n(argName:'controllername', longOpt:'controllername', args:1, required:true, type:GString, 'controllername')
cli.a(argName:'appname', longOpt:'applicationname', args:1, required:true, type:GString, 'appname')
cli.p(argName:'pfad', longOpt:'pfad', args:1, required:true, type:GString, 'pfad')
cli.f(argName:'forece', longOpt:'force', args:0, required:false, type:GString, 'force')

def opt = cli.parse(args)

def controllername = "${opt.n}Controller.groovy"
def appname = "${opt.a}"
def pfad = "${opt.p}"
def force 
cpath = ("${rootpath}\\${appname}\\WEB-INF\\classes\\MVC\\root\\${pfad}\\${controllername}" =~ /[\\]/).replaceAll('/')

println cpath

File oFile = new File(cpath)
if (oFile.exists()) {
   if (opt.f) {
      println "\n** Controller existiert, wird ueberschrieben \n"
      }
   else {
      println "\n** Controller existiert, wird nicht ueberschrieben \n"
      System.exit(1)
      }
   }
String fileBuffer = """/**
 *
 * Controller ${opt.n}
 * 
 */
package MVC.root.${pfad}

import framework.helper.Viewhandler
import MVC.domain.${opt.n}Domain



${opt.n}Domain ${opt.n.toLowerCase()} = new ${opt.n}Domain(
   db:db.dbh,
   autor:request.getSession().getAttribute('personalnummer')?.toInteger()
   )

// --- Aufteilung fuer Riese   ------------------------------------------
def gridrows = {id,closure->
// ----------------------------------------------------------------------
   // 
   // 
   // 
   ${opt.n.toLowerCase()}.eachDomain("(1=1)",closure)
   }


bindings  = [
   gridrows : gridrows
   ]


Viewhandler crud = new Viewhandler(
   controller:this,
   action:'grid',
   domain:${opt.n.toLowerCase()},
   viewBindings:bindings
   )

crud.run()

"""
oFile.write fileBuffer

// ***********************************************************
// ********** VIEWER *****************************************

vpath = ("${rootpath}\\${appname}\\WEB-INF\\classes\\MVC\\root\\${pfad}\\grid.tpl" =~ /[\\]/).replaceAll('/')
oFile = new File(vpath)
if (oFile.exists()) {
   if (opt.f) {
      println "\n** Viewer existiert, wird ueberschrieben \n"
      }
   else {
      println "\n** Viewer existiert, wird nicht ueberschrieben \n"
      System.exit(1)
      }
   }

fileBuffer = """<%
/**
 *
 * viewer fuer Controller ${opt.n}
 * 
 */

// Imports
import java.text.DecimalFormat
import helper.DateConverter

/** 
 * Diverse Objekte
 */
DateConverter dc = new DateConverter()
Boolean fromcgi = false
def taglib = new MVC.taglib.Taglib(request:request)

%>
<h1 class="blockname">${opt.n}</h1>

  <!--                                      -->
  <!--   Ausgabe GRID                       -->
  <!--                                      -->

<%=taglib.getHiddenfieldsFromCGI(fields:['path'])%>
<table border="0" cellpadding="0" cellspacing="0">
<%
 out<<taglib.listheader(
   class:'listHeader',
   th:[
    'ID',
    'Spalte-1',
    'Spalte-2',
    '&nbsp;',
    '&nbsp;'
    ])

   // Zeilen fuer Key aufrufen
   Integer key = 1
   gridrows(key) {rec->

      cntAufteilungszeilen++  // Zahle Zeilen
      
      out<<taglib.gridRow (
         domain:rec,
         editbuttontext:'',
         deletebuttontext:'',
         values:[
            'value-1',
            'value-2'
            ],
         hidden:[
            'key'
            ]
         )
      }

%>
</table>
 """
oFile.write fileBuffer
