/**
 * Dies ist ein umfangreiches Szenario.
 * 
 * + ANmelden an das System
 * + Navigieren
 * + Lov (Masken Layout)
 *   - Aus Liste einen Auswaehlen
 *   - Veraenern den Eintrag
 *   - Veraendern Rueckgaeng machen
 * + User (Grid Layout)
 *   - Anlegen eines Users
 *   - Veraendern des Users
 *   - loeschen des Users
 * + Abmelden 
 * 
 */
import com.gargoylesoftware.htmlunit.WebClient

/** KONFIGURATIONS-SECTION */
AUFTRAGID = '16605'
HOST='localhost'
APPNAME='mframe'

webClient = new WebClient()
page = ''
form = ''
button = ''
link = ''
field = ''
testStatus = []
testno = 0

/**
 * Hilfsroutine
 * Speichert LOG Eintraege 
 *
 */
void setLog(testno,testTitle) {
   testStatus.add(sprintf('%03d | %s',testno,testTitle))
   }

/**
 * von der aktuellen Funktionsliste eine Link
 * zu einem Pfad aufrufen und das
 * Ergebnis kontrollieren
 * 
 * @path herfpath    Pfad zu Funktion
 * 
 */
void gotoLink(String hrefpath) {
   link = page.getAnchorByHref("/mframe/start.groovy?path=${hrefpath}")
   print '.'
   page = link.click()
   assert page.getTitleText() =~ /\[${hrefpath}\]/
   }

/**
 * Hilfsmethode
 * Stellt die Applikation in die 'Grundstellung'
 *
 */
void gotoTop() {
   page = webClient.getPage("http://${HOST}:8080/${APPNAME}/start.groovy?path=/root")
   }


/**
 * Test anmelden 
 *
 */
void checkLogin(Integer testno,String testTitle) {
   print "${testno} ${testTitle}"
   page = webClient.getPage("http://${HOST}:8080/${APPNAME}/")
   assert page.getTitleText() =~ /^mframe::login/
   
   form = page.getFormByName('edit')
   def username = form.getInputByName('username')
   def password = form.getInputByName('password')
   username.setValueAttribute('admin')
   password.setValueAttribute('admin')
   button = form.getInputByValue('Anmelden')
   page = button.click()

   assert page.getTitleText() =~ /\[\/root\]/
   println "ok"
   }

/**
 * Dieses Szenario teste den Aufruf eine
 * Funktion und die Methode gotoTop und gotoLink
 *
 */
void checkGotoExtras(Integer testno,String testTitle) {
   print "${testno} ${testTitle} (2 Steps) "
   gotoTop()
   gotoLink('/root/extras')
   println "ok"
   }


/**
 * Dieser Szenario testet einen durchlauf
 * mit Auswahlliste und Maskenlayout
 * an Hand der List of Value Tabelle (LOV)
 * HINT:
 *   die Tabelle der Auswahlliste muss mit der ID Option 'list'
 *   gekennzeichnet sein.
 *   Beispiel: <table id="list">
 *
 */
void checkLov(Integer testno,String testTitle) {
   print "${testno} ${testTitle} (7 Steps) "
   gotoTop() // Startmaske aufrufen
   gotoLink('/root/extras') // gehe zu Extras
   gotoLink('/root/extras/lov') // und in die LOV Liste

   print '.'
   /**
    * Das Ermitteln des Lovkeys ist etwas 'trickreich'
    * In der Auswahliste werden die LOV Eintraege als Tabelle dargestellt.
    * Die Liste besteht aus einer Ueberschrift und darunter die 
    * Eintraege. In der 1. Spalte wird das Icon in der zweiten Spalte
    * die ID des Loveintrags anzeigt.
    * Diese Routine nimmt aus der Zweiten Zeile den zweiten Eintrag und
    * ermitelt aus dem Eintrag den LOV-Key.
    */
   // Wir holen die Tabelle
   def table = page.getHtmlElementById("list")
   // Extrahieren die Zeilen
   List rows = table.getRows()

   String ID = rows[1].getCells()[1].asText()

   // Aufruf der LOV Maske
   print '.'
   page = webClient.getPage("http://${HOST}:8080/${APPNAME}/start.groovy?path=/root/extras/lov&id=${ID}&action=edit&filter=")
   assert page.getTitleText() =~ /\[\/root\/extras\/lov\]/
   print '.'

   // Speichern eines Eintrags in der Maske
   form = page.getFormByName('edit')
   String saveValue =  form.getInputByName('lovFlag4').getValueAttribute()

   form.getInputByName('lovFlag4').setValueAttribute('-- TESTEINTRAG --')
   button = form.getInputByValue('speichern')
   print '.'
   page = button.click()
   assert page.getTitleText() =~ /\[\/root\/extras\/lov\]/

   page = webClient.getPage("http://${HOST}:8080/${APPNAME}/start.groovy?path=/root/extras/lov&id=${ID}&action=edit&filter=")
   form = page.getFormByName('edit')
   form.getInputByName('lovFlag4').setValueAttribute(saveValue)
   button = form.getInputByValue('speichern')
   print '.'
   page = button.click()

   println "ok"
   }

/** 
 * Dieses Szenario testet das Verhalten
 * im Gridlayout an Hand der Tabelle USER
 *
 * HINT:
 *   Die Tabelle der Zeilen muss mit der ID Option gekennzeichnet werden
 *   Beispiel: <table border="0" cellpadding="0" cellspacing="0" id="grid">
 * 
 * VORBEDINGUNG:
 *   Zum testen wir ein Benutzer mit namen __TEST__ angelegt. Dieser
 *   darf NICHT vorhanden sein. 
 * 
 */
void checkUser(Integer testno,String testTitle) {
   print "${testno} ${testTitle} (7 Steps) "
   print '.'

   String testUserName = '__TEST__'


   // Navigiere zur 'user' Seite
   gotoTop()
   gotoLink('/root/extras')
   gotoLink('/root/extras/user')
   // in der globalen Variable 'page' ist die akuelle Seite 'user'

   /**
    * Speichern eines Neuen Benutzers
    */
   form = page.getFormByName('edit')
   form.getInputByName('username').setValueAttribute(testUserName)
   form.getInputByName('realname').setValueAttribute('-- Das ist ein Testuser')
   form.getInputByName('password').setValueAttribute('keines')
   button = form.getInputByName('submit-new')
   page = button.click()

   print '.'
  /**
   * das ermitteln des Key ist wieder 'trickreich'
   * Wir durchsuchen die Tabelle nach dem Namen des
   * Angelegten Users (__TEST__). Die Spalte links
   * daneben enthaelt die Nummer. Diese wird aus
   * der Tabelle extrahiert.
   */
   def table = page.getHtmlElementById("grid")

   List rows = table.getRows()
   String userID = ''

   // Suchen der ID
   rows.each{row->
      String id = row.getCells()[0]?.asText()
      String name = row.getCells()[1]?.asText()
      if(name =~ /${testUserName}/) {
         userID = id
         }
      }
   // Prfen ob etwas gefunden wurde
   assert userID =~ /\d+/

  /**
   * Verndern eines Eintrags...
   */
   form = page.getFormByName("edit-personalnummer-${userID}")
   button = form.getInputByName('submitbutton')
   button.click()
   page = form.submit()

   form = page.getFormByName("edit")
   form.getInputByName('realname').setValueAttribute('__$__')
   button = form.getInputByName('submit-save')
   page = button.click()
   page = form.submit()
   print '.'

  /**
   * Pruefen ob die Aendern funktioniert hat
   */

   // Reload 
   table = page.getHtmlElementById("grid")
   rows = table.getRows()
   rows.each{row->
      String id = row.getCells()[0]?.asText()
      String name = row.getCells()[1]?.asText()
      String realname = row.getCells()[2]?.asText()
      if(id ==  userID) {
         assert realname == '__$__' : "${userID} hat nicht richtigen realname: ${realname}"
         }
      }
   print '.'
   
  /**
   * lschen eines Eintrags...
   */
   form = page.getFormByName("era-personalnummer-${userID}")
   button = form.getInputByName('submitbutton')
   page = button.click()
   page = form.submit()

   print '.'
  /**
   * Pruefen ob loeschen funktioniert hat
   */
   table = page.getHtmlElementById("grid")
   rows = table.getRows()
   rows.each{row->
      String id = row.getCells()[0]?.asText()
      String name = row.getCells()[1]?.asText()
      String realname = row.getCells()[2]?.asText()
      if(id ==  userID) {
         assert true : "Bei Loeschen gab es ein Problem"
         }
      }
   println 'ok'
   }


/**
 * Dieses Szenario testet die 
 * Abmeldefunktion ueber die Funktionsleiste
 * 
 */
void checkAbmelden(Integer testno,String testTitle) {
   print "${testno} ${testTitle} (2 Steps) "
   print '.'
   gotoTop()
   link = page.getAnchorByHref("/${APPNAME}/start.groovy?path=/root/extras")
   page = link.click()
   link = page.getAnchorByHref("/${APPNAME}/start.groovy?path=/root/extras/abmelden")
   page =link.click()
   assert page.getBody() =~ /ANMELDUNG/
   setLog(testno,"${testTitle} abmelden ok")
   println 'ok'
   }

/** 
 * Einzelne Sub-Szenario aufrufen
 * 
 */
println "*\n* Szenario 1: anmelden, navigieren, Masken und Grid-layout,  abmelden\n*"
checkLogin(++testno,'Login ')
checkGotoExtras(++testno,'goto Extras ')
checkLov(++testno,'Masklayout ')
checkUser(++testno,'Gridlayout ')
checkAbmelden(++testno,'Abmelden ')

