package MVC.domain

/**
 * Jobs
 * HINT
 *    Der PK ist nicht eine Zahl
 *    und kan somit nicht hochgezaehlt werden
 */
class JobsDomain extends framework.database.DAO.DataAccessObject {

   //
   // Deklaratin der Felder
   //
   String  jobID                     // "JOB_ID" VARCHAR(10),
   String  jobTitle                  // "JOB_TITLE" VARCHAR(35) NOT NULL,
   Integer minSalary                 // "MIN_SALARY" INTEGER,
   Integer maxSalary                 // "MAX_SALARY" INTEGER)
    
   // Definiton der Metadaten
   //
   def meta = [
      idfield:[db:'JOB_ID',domain:'jobID'],     // Verbindung der ID Felder
      tablename: 'JOBS',                        // Tabellenname

      nextval:{
         Integer id = (db.firstRow('select MAX(EMPLOYEE_ID)+1 from EMPLOYEES')[0]).toInteger()
         // Abfangen leer Tabelle
         if (id == null) id = 1

         // Wert zurckgeben
         return id
         },

      validate:{                             // Ueberprfung ob PK angegeen wurde
         return ((this.jobID?:'')=='' ? 'Keine Job ID eingegeben' : '')
         },

      fields: [                                 // Felder
         jobID: [                                  // JOBID
            dbfield:'JOB_ID',                      // Datenbankfeld
            type:'String',                         // Datentyp
            ],
         jobTitle:   [dbfield:'JOB_TITLE',type:'String',nullable:false],
         minSalary:  [dbfield:'MIN_SALARY', type:'Integer'],
         maxSalary:  [dbfield:'MAX_SALARY', type:'Integer']
         ]
      ]
  /**
   * Liefert eine Datasource fuer Selectbox
   * 
   */
   List selectDatasource(String jobID) {
      List datasource = []
      this.eachDomain('(1=1)','JOB_TITLE') {dom->
         datasource.add([
            dom.jobID,
            dom.jobTitle,
            (dom.jobID == jobID)
            ])
         }
      return datasource
      }

   } // END of CLASS
