package MVC.domain

class RechtDomain extends framework.database.DAO.DataAccessObject {
   //
   // List of Values
   //
   //
   // .--update--.
   // -- wann----+-wer+-- was -------------------------------------
   // 02.11.2007 | ny | erstellt
   //            |    |

   Integer id
   String  rechtLOVID
   Integer personalNummer
   Date    lastUpdate
   String  remark
   Integer gespeichertVon   // Benutzer
   String  flag1
   String  flag2
   String  flag3
   String  flag4

   // transient Daten
   Integer autor      // wird beim erzeugen der Klasse im Konstruktor angegeben
                      // bein speichern wird dann diese Variable in umgespeichert siehe before_write

   def meta = [
      idfield:[db:'RECHTID',domain:'id'],
      tablename: 'RECHT',
      before_write:{
         if (this.id == null) {
             this.id = this.nextval()
            }
         },
      nextval:{
         return db.firstRow('select MAX(RECHTID)+1 from RECHT')[0]
         },
      fields: [
         id:                  [dbfield:'RECHTID',type:'Integer'],
         rechtLOVID:          [dbfield:'RECHTLOVID'],                    // --> LOV (Klasse: RECHTE)
         personalNummer:      [dbfield:'PERSONALNUMMER',type:'Integer'], // --> RR_DATEN(PERS_WWW)
         lastUpdate:          [dbfield:'RECHTLASTUPDATE',type:'Date'],
         remark:              [dbfield:'RECHTREMARK'],
         gespeichertVon:      [dbfield:'RECHTGESPEICHERTVON',type:'Integer'],
         flag1:               [dbfield:'RECHTFLAG1',type:'String'],
         flag2:               [dbfield:'RECHTFLAG2',type:'String'],
         flag3:               [dbfield:'RECHTFLAG3',type:'String'],
         flag4:               [dbfield:'RECHTFLAG4',type:'String']
         ]
      ]

  /**
   * Liefert fuer angegeben Persoanlnummer alle Rechte des Nutzers
   *
   * usage: RechteListe(775)
   */
   List RechteListe(Integer personalNummer) {

      List retVal = []
      this.db.eachRow('select * from RECHT') {row->
         if (row.PERSONALNUMMER == personalNummer) {
            retVal.add(row.RECHTLOVID)
            }
         }
      return retVal
      }
   }