package MVC.domain

class UserDomain extends framework.database.DAO.DataAccessObject {

   Integer personalnummer
   String  username
   String  realname
   String  password

   def meta = [
      idfield:[db:'USERID',domain:'personalnummer'],
      tablename: 'USER',
      before_write:{
         if (this.personalnummer == null) {
             this.personalnummer = this.nextval()
            }
         },
      nextval:{
         return db.firstRow('select MAX(USERID)+1 from USER')[0]
         },
      fields: [
         personalnummer:      [dbfield:'USERID',type:'Integer'],
         username:            [dbfield:'USERNAME',type:'String'],
         realname:            [dbfield:'REALNAME',type:'String'],
         password:            [dbfield:'PASSWORD',type:'String']
         ]
      ]
   
  /** 
   * Gibt eine Liste aller 
   * sortiert nach Name zurueck
   */
   List listAll(def personalNummer) {
      List retval = []

      this.eachDomain('(1=1)','USERNAME') {dom->
         retval.add([dom.personalnummer,dom.username,dom.personalnummer == personalNummer])
         }
      return retval
      }


  /**
   * Liefert den Benutzername basierend auf einer Nummer
   */
   String getUsername(Integer persoanlnummer) {
      if (personalnummer == null) return 'k.a.'
      this.get(personalnummer)
      return ths.username
      }

   } // END of Class