<%
/**
 * Anzeigen der Auwahlliste
 * 
 * Es wird eine Liste der gefilterten Datensaetze aus der EMPLOYEES Tabelle
 * angezeigt. Die Datenstze enthalten eine Bearbeitungsschaltflaeche.
 * Nach dem bettigen der Schaltflaeche wird der Edit Viewer aufgerufenn.
 * 
 * Zustzlich wird im Funktionsbereich der Navigation eine Schaltflche
 * zum Erzeugen eines neuen Datensatzes angeboten.
 * 
 */


/**
 * Diese Methode ermoeglicht es 
 * weiter Schaltflaechen im Funktionsbereich zu definierten
 */
addFunction(
   path:path,                    // Path
   text:'Neuanlage',             // Anzeigetext
   title:'Mitarbeiter anlegen',  // Popuphelp
   cgiparameter:[                // Definiton von CGI Parameter
      'action=grid',
      'submitbutton=newedit'
      ]                    
   )

%>
<h1 class="blockname">List of Values</h1>


<!--
 Einbau des Paginierungswidget.
 Im Controller wird aus den Inhalten des CGI
 das SQL Statment konstruiert.
-->

${
/* Erzeugen eines Listwidgets */
taglib.listwidget(
   table:'EMPLOYEES',
   where:filter(),
   filter:taglib.cgiparam(name:'filter',nvl:''),
   title:'Betreff',
   filterwidget:true,
   db:db)
   }

<table border="0" cellpadding="1px" cellspacing="1" width="100%" id="grid">

  <colgroup>
    <col width="1%">
    <col width="1%">
    <col width="1%">
    <col width="1%">
    <col width="99%">
  </colgroup>

  <%
  /**
   *
   * Erzeugen der Ueberschriftszeile
   * 
   */
   out<<taglib.listheader(
      class:'listHeader',
      th:[
        'ID',
        'Nachname',
        'Vorname',
        '&nbsp;'
        ],
      tr:true
      )
   
  /**
   *
   * Ausgabe der Datenzeilen
   * Es wird eine Routine aus dem Controller aufgerufen.
   * Der Routine wird eine Closure aufgerufen. Die Datensaetze werden
   * gefiltert.
   *
   */   
   list {rec->
      out<<taglib.gridRow (               // Datenzeile wird generiert
         domain:rec,                      // Datensatz, dieser wird zur gewinnung der Metadaten bentigt.
         nobr:true,                       // Die Zellen werden nicht umgebrochen
         values:[                         // Auszugebende Felder
            rec.employeeID,
            rec.lastName,
            rec.firstName,
            ],
         hidden:['employeeID'],                // Den AKtionsschaltflchen wird als Hidden Fild die LOV ID mitgegeben.

         // Fuer jede Zeile werden Standardmaessig die Schaltflchen Bearbeiten (SUBMITBUTTON_EDIT) 
         // und lschen (SUBMITBUTTON_DELETE) angezeigt. Die Option gridbuttons beeinflusst dieses Verahlen
         // wird diese mitgegeben, so werden nur die Schaltflchen angezeigt, welche in der Liste enthalten sind.
         gridbuttons:[MVC.taglib.Taglib.SUBMITBUTTON_EDIT] 
         )
      }
   %>
</table>

<%
/**
 * Demonstriert die Verwendung von SQL Funktionen
 * 
 * MIN, MAX, COUNT, SUM und AVT
 * 
 */
%>
<div style="background-color:#EFEFEF;width:255px;padding:3px;margin-top:5px;border:1px solid black;margin-left:32px;">
<h1>Statitstik</h1>
Anzahl Gesamt (COUNT(*)): <b>${domain.sqlCount()}</b><br />
Summe Geh&auml;lter (SUM): <b>${sprintf('%.2f',domain.sqlSum(field:'salary'))}</b><br />
Durchschnittliches Gehalt (AVG): <b>${sprintf('%.2f',domain.sqlAvg(field:'salary'))}</b><br />
Kleinstes Gehalt (MIN): <b>${sprintf('%.2f',domain.sqlMin(field:'salary'))}</b><br />
Gr&ouml;&szlig;tes Gehalt (MAX): <b>${sprintf('%.2f',domain.sqlMax(field:'salary'))}</b><br />
</div>
<p>