<%
/**
 * Ist der Viewer fuer die dynamischen Abragen
 * 
 */
import MVC.taglib.Taglib
import helper.DateConverter

Taglib taglib = new Taglib(request:request)

%>
Es wird die Verwendung von dynamischen Abfragen demonstriert.<br />
Was daran <b><i>so toll</i></b> sein soll, wei&szlig; ich nicht, aber was solls...<br />
Die Syntax wurder der von grails angepasst. Es wurde statt findAll die in groovy/mframe
grbr&auml;uchliche Form eachDomain verwendet.
<h1>Beispiel - 1</h1>
<div style=";border:1px solid navy;background-color:#F2F2F2">
<tt style="font-family:Courier;">
   jobs.eachDomainByJobTitleLikeAndMinSalaryGreaterThan(<br />
      orderby:['minSalary','JobID'],<br />
      conditions:['Pu%',1000]) { ... } <br />
</tt>
</div>
Dies entspricht:<br />
jobs.eachDomain("JOB_TITLE like 'Pu%' and MIN_SALARY > 1000",'MIN_SALARY,JOB_ID') { ... } <br />
Was leichter zu lesen und zu warten ist mag jeder f&uuml;r sich entscheiden.
<p>
<table cellspacing="1">
${taglib.colgroup(4)}
<%
out<<taglib.listheader(
   th:[
      'Job ID',
      'TItel',
      'min&nbsp;Gehalt',
      '&nbsp;'
     ]
  )

query1() {result1->
   out<<taglib.listrow(
      td:[
         result1.jobID,
         result1.jobTitle,
         taglib.formatDecimal(zahl:result1.minSalary),
         '&nbsp;'
         ]
      )
   }
%>
</table>
</p>
<h1>Beispiel - 2</h1>
<div style="border:1px solid navy;background-color:#F2F2F2">
<tt style="font-family:Courier;">
   jobs.eachDomainByJobID(<br />
      conditions:['AC_ACCOUNT']) { ... }</tt>
</div>
<p>
<%
query2() {result2->
   out<<"Resultat: <b>${result2.jobTitle}</b>"
   }
%>
</p>
<h1>Syntax</h1>
Allgemeine Form:
<tt style="font-family:Courier;text-decoration:underline">eachDomainBy</tt><tt style="font-family:Courier">[&lt;Domain-Fieldname&gt;&lt;Condition&gt;[&lt;Log-Operator&gt;],...]</tt>
<h2>Feldname</h2>
Um m&ouml;gliche Namenskonflikte zu vermeinden k&ouml;nnen Feldnamen mit gro&szlig;en Anfangsbuchstaben
notiert werden. Beispiel: "JobID" entspricht "jobID".

<h2>Condition</h2>
<ul>
 <li style="font-family:Courier">Equal</li>
 <li style="font-family:Courier">NotEqual</li>
 <li style="font-family:Courier">LessThan</li>
 <li style="font-family:Courier">LessThanEquals</li>
 <li style="font-family:Courier">GreaterThan</li>
 <li style="font-family:Courier">GreaterThanEquals</li>
 <li style="font-family:Courier">Like</li>
 <li style="font-family:Courier">NotLike</li>
 <li style="font-family:Courier">IsNull</li>
 <li style="font-family:Courier">IsNotNull</li>
</ul>
Wenn keine Condition angegeben wurde, wird vom System Equal angenommen (Siehe Beispiel 2).
<h2>Log-Operatoren</h2>
Als logische Operatoren sind <span style="font-family:Courier">And</span> und <span style="font-family:Courier">Or</span> zugelassen.
Klammerung ist nicht m&ouml;glich.

<h1>M&ouml;gliche Komplikationen</h1>
<p>
Namenskonflikte:<br />
Das System versucht die Feldnamen und die Operationen aus dem String zu "eraten". Dabei ist die Gro&szlig; und Kleinschreibung
"Camelstyle" behilflich. Es besteht die aber die M&ouml;glichkeit, dass in Feldnamen &auml;hnliche Muster enhalten sind. 
"salaryLessThan" "minAndere" etc. Dann gibt es 'Br&ouml;seln'.</p><p>
Werte:<br />
Die Abfragen werden in prepared statments formuliert und der Inhalt der conditions Option uebergeben. Dies kann zu Schwierigkeiten 
f&uuml;hren, da der konkrete JDBC Treiber nicht immer eine Korrekte Typenkonvertion durchf&uuml;hrt.<br />
Der Entwickler muss m&ouml;glicherweise selbst f&uuml;r die geeignete Umwandlung sorgen.