package MVC.root.wartung.isql

// --- ISQL ----------------------------
//
// Interaktives SQL
//
//
import groovy.sql.Sql
import MVC.taglib.Taglib

def taglib = new MVC.taglib.Taglib(request:request)
String result = 'default'

String sql = taglib.cgiparam(name:'sql',nvl:'')
Integer maxRow = 0
try{
    maxRow = taglib.cgiparam(name:'maxrow',nvl:'0').toInteger()
   }
catch (Exception e) {
   maxRow = 16
   }

Integer cntLine = 0
Integer cntCols = 0
List colNames = []
boolean hasError = false

if (sql != '') {
   result += '<table>'
   try{
      db.dbh.query(sql) {rs->
         cntLine++

         if (cntLine==1) {
            def meta = rs.metaData
            result += '<tr>'
            cntCols = meta.columnCount
            if (cntCols > 0) {
               for (i in 0..<cntCols) {
                 colNames.add(meta.getColumnLabel(i+1))
                  result += "<th class=\"listheader\">${meta.getColumnLabel(i+1)}</td>"
                  }
               }
            result += '</tr>'
            return
            }
         }
      }
   catch (Exception e) {
      hasError = true
      result += '<td colspan="99" style="background-color:yellow">'+e.message+'<td>'
      }


   long start = new Date().getTime();
   if (!hasError) {
      cntLine = 0
      db.dbh.eachRow(sql) {row->
         cntLine++
         if (maxRow != 0 && cntLine > maxRow) return
         result += '<tr>'
         colNames.each{name->
         Integer colInx = row.findColumn(name)
            result += "<td>${row[colInx-1]}</td>"
            }
         result += '</tr>'
         }
      }
    long runningTime = new Date().getTime() - start;

   result += '</table>'
   result += "Runningtime: ${runningTime}ms"
   }
view(filename:'isql.tpl',bindings:[
   result:result,
   sql:sql
   ])