<% 
/**
 * HINTERGRUND
 *    Zeigt die Verwendung des Viewhandlers im Edit-Mode
 *    Dies ist eine Editiermaske. Es wird ein Prompt-Value Layout
 *    angezeigt.
 *
 * BEISPIELE (Taglib)
 *     Hidden Fields
 *     Eingabe Felder
 *     Verschieden Eingabefelder
 *
 */
import MVC.domain.LovDomain

// Taglibobjekt erzeugen
//
def taglib = new MVC.taglib.Taglib(request:request) 

// Zur bequemeren Bearbeitung Daten aus CGI umspeichern
//
String   path              = taglib.cgiparam(name:'path',nvl:'')
String   submitbutton      = taglib.cgiparam(name:'submitbutton',nvl:'')
Integer  lovID             = taglib.cgiparam(name:'lovID',nvl:'0').toInteger()

%>
<!-- Begin der FORM -->
${taglib.form(name:'edit')} <!-- Stellt einen Standard-Form Tag zu Verfuegung -->

   <!-- 
     Hiddenfelder:
     Die Felder werden als EL Anweisungen ausgefhrt
   -->
   ${taglib.hidden name:"path",     value:path}
   ${taglib.hidden name:"filter",   value:taglib.cgiparam(name:'filter',nvl:'')}
   ${taglib.hidden name:'action',   value:'edit'}
   <table border="0" cellpadding="1px" cellspacing="1">
    
    <!-- 
    Beispiel einer Feldes das Angezeigt und als hidden deklariert wird.

    ACHTUNG Wird ein Feld als disabled gekennzeichnet (type:'disabled') 
    so wird dieses nicht an das CGI uebergeben.
    -->
    
    ${
    /* BEISPIEL: Feld als EL-Anweisung */
    taglib.promptinput(
       name:'lovID',
       prompt:'ID',
       size:5,
       fromcgi:true,
       nvl:fields?.lovID,
       type:'displayandhidden',
       value:fields?.lovID)
       }

   <%
   /**
    * BEISPIEL als GSP Code
    * ---------------------
    *
    * Selectbox mit Datensource
    */
   out<<taglib.promptinput(
      name:'lovClass',
      prompt:'Klasse',
      type:'select',
      datasource:domain.lovList(
         classname:'CLASS',
         selected:fields.lovClass?:''
         )
      )

   // Texteingabefeld
   out<<taglib.promptinput(
      name:'lovKey',  
      prompt:'Schl&uuml;ssel',
      size:32,
      maxlength:32,
      fromcgi:false,
      nvl:'',
      value:fields.lovKey,
      disabled:false
      )

   out<<taglib.promptinput(
      name:'lovValue',
      prompt:'Wert',
      size:128,
      maxlength:255,
      fromcgi:false,
      isnull:'',
      value:fields.lovValue)
      %>

   <!-- Die restlichen Felder -->
   ${taglib.promptinput(name:"lovFlag1",prompt:"Flag-1",size:16,maxlength:255,fromcgi:false,nvl:'',value:fields.lovFlag1)}
   ${taglib.promptinput(name:"lovFlag2",prompt:"Flag-2",size:16,maxlength:255,fromcgi:false,nvl:'',value:fields.lovFlag2)}
   ${taglib.promptinput(name:"lovFlag3",prompt:"Flag-3",size:16,maxlength:255,fromcgi:false,nvl:'',value:fields.lovFlag3)}
   ${taglib.promptinput(name:"lovFlag4",prompt:"Flag-4",size:16,maxlength:255,fromcgi:false,nvl:'',value:fields.lovFlag4)}
   ${taglib.promptinput(name:'lovRemark',prompt:'Bemerkung',type:'textarea',maxlength:255,rows:4,cols:64,fromcgi:false,value:fields.lovRemark)}

   <!-- 
      Wenn ein ID Uebergeben wurde wird der Savebutton/Editbutton wenn nicht nur Savebutton ausgegeben  
    -->
   <tr>
     <td colspan="99">
        <%=(submitbutton == taglib.SUBMITBUTTON_NEWEDIT ? taglib.getNewButton() : taglib.getSaveAndDeleteButton())%>
     </td>
   </tr>

  </table>
</form>
