<%
/**
 * Anzeigen der Auwahlliste
 * 
 * Es wird eine Liste der gefilterten Datensaetze aus der LOV Tabelle
 * angezeigt. Die Datenstze enthalten eine Bearbeitungsschaltflaeche.
 * Nach dem bettigen der Schaltflaeche wird der Edit Viewer aufgerufenn.
 * 
 * Zustzlich wird im Funktionsbereich der Navigation eine Schaltflche
 * zum Erzeugen eines neuen Datensatzes angeboten.
 * 
 */


/**
 * Eine weiter Funktionsschaltflche 
 * zur Neuanlage wird eingebaut
 */

addFunction(
   path:path,
   text:'Neuanlage',
   title:'',
   cgiparameter:['action=grid','submitbutton=newedit']
   )

%>
<h1 class="blockname">List of Values</h1>
<p>Die List of Value Tabelle (LOV) stellt ein zentrales Datenrepository f&uuml;r die 
gesamte Appliaktion dar. Sie besteht aus einer Klasse (LOVCLASS), diese fasst alle eintr&auml;ge
die zu einer Gruppe geh&ouml;ren zusammen. Der Schl&uuml;ssel (LOVKEY) stelle eine in der Klasse eindeutige
Kennung dar. Im Wertefeld (LOVVALUE) ist der Inhalt des Schl&uuml;ssel gespeichert.
Zus&auml;tzlich sind noch fuer jedes Key/Value Paar noch bis zu vier Flags (LOVFLAGn) zur Verwendung
durch die Applikation vorgesehen.</p>

<table border="0" cellpadding="1px" cellspacing="1" width="100%" id="grid">

  <colgroup>
    <col width="1%">
    <col width="1%">
    <col width="1%">
    <col width="1%">
    <col width="99%">
  </colgroup>

  <%
  /**
   *
   * Erzeugen der Ueberschriftszeile
   * 
   */
   out<<taglib.listheader(
      class:'listHeader',
      th:[
        'ID',
        'Klasse',
        'Schl&uuml;ssel',
        'Wert',
        '&nbsp;'
        ],
      tr:true
      )
   
  /**
   *
   * Ausgabe der Datenzeilen
   * Es wird eine Routine aus dem Controller aufgerufen.
   * Der Routine wird eine Closure aufgerufen. Die Datensaetze werden
   * gefiltert.
   *
   */
   list {rec->
      out<<taglib.gridRow (               // Datenzeile wird generiert
         domain:rec,                      // Datensatz, dieser wird zur gewinnung der Metadaten bentigt.
         nobr:true,                       // Die Zellen werden nicht umgebrochen
         values:[                         // Auszugebende Felder
            rec.lovID,
            rec.lovClass,
            rec.lovKey,
            rec.lovValue
            ],
         hidden:['lovID'],                // Den AKtionsschaltflchen wird als Hidden Fild die LOV ID mitgegeben.

         // Fuer jede Zeile werden Standardmaessig die Schaltflchen Bearbeiten (SUBMITBUTTON_EDIT) 
         // und lschen (SUBMITBUTTON_DELETE) angezeigt. Die Option gridbuttons beeinflusst dieses Verahlen
         // wird diese mitgegeben, so werden nur die Schaltflchen angezeigt, welche in der Liste enthalten sind.
         gridbuttons:[MVC.taglib.Taglib.SUBMITBUTTON_EDIT] 
         )
      }
   %>


</table>