/**
 * Controller zur Bearbeitung
 * der Rechte Tabelle (RECHT)
 * 
 * Dieses Skript demonstriert die Funktion 
 * eachDomain mit Optionen
 * 
 */
package MVC.root.extras.recht

import MVC.domain.RechtDomain
import framework.helper.Viewhandler

/**
 * Liste von Rechten
 */
def list = {Closure closure->
   RechtDomain recht = new RechtDomain(db:db.dbh)

   recht.eachDomain(orderby:'RECHTID') {theRecht->
      closure.call(theRecht)
      }
   }

/**
 * Konstruktion und ausfuehren des CRUD
 * Dem Handler wird die Routine 'list' zur
 * Datensatzgewinnung mitgegeben.
 */
Viewhandler crud = new Viewhandler(
    domain: new RechtDomain(db:db.dbh),
    controller:this,
    action:'grid',
    viewBindings:[
       list:list
       ]
    )

crud.run()
