<%
/**
 * Dieser Viewer demonstriert
 * die Verwendung von Grid Layout.
 * 
 */
import MVC.domain.RechtDomain    // Recht Domain
import MVC.domain.LovDomain
import MVC.domain.UserDomain
import MVC.taglib.Taglib

// Taglib Objekt erstellen
Taglib taglib = new Taglib(
   request:request,
   httpMethod:Taglib.HTTP_METHOD_GET
   )

// User Objekt erstellen
UserDomain user = new UserDomain(db:db.dbh)

Map editmask = [
   hiddenfields : [
      taglib.hidden(name:'path',value:"${taglib.cgiparam(name:'path',nvl:'')}"),
      taglib.hidden(name:'action', value:'grid')
      ],
   fields : [
      taglib.promptinput(
         name:'id',
         prompt:'',
         nohtml:true,
         type:'displayandhidden',
         fromcgi:false,
         value:fields.id
         ),
      taglib.promptinput(
         name:'personalNummer',
         prompt:'',
         nohtml:true,
         type:'select',
         fromcgi:false,
         datasource:new MVC.domain.UserDomain(db:db.dbh).listAll(fields.personalNummer)
         ),
      taglib.promptinput(
         name:'rechtLOVID',
         prompt:'',
         nohtml:true,
         fromcgi:false,
         popuphelp:'Title',
         type:'select',
         datasource:new MVC.domain.LovDomain(db:db.dbh).lovList(
            name:'rechtLOVID',
            classname:'RECHTE',
            selected:fields.rechtLOVID
            )
         ),
      taglib.gridSubmitbutton(action,submitbutton)
      ]
   ]

%>

<h1 class="blockname">Rechte</h1>
<p>
Ein Benutzer kann mehrer Rechte zugeordnet werden
</p>

<table border="0" cellpadding="1px" cellspacing="1" width="100%" id="grid">
  <colgroup>
    <col width="1%">
    <col width="1%">
    <col width="1%">
    <col width="99%">
  </colgroup>

  <%
  // Erzeuge Ueberschriften
  out<<taglib.listheader(
   class:'listHeader',
   th:[
    'ID',
    'Personalnummer',
    'Recht',
    '&nbsp;'
    ],
    tr:true
    )

   Boolean showNewInput = true

   list {rec->

      if (showNewInput) showNewInput = !(rec.personalNummer == fields.personalNummer)

      user.get(rec.personalNummer)
      out<<taglib.gridEdit (
         domain:rec,
         editmask:editmask,
         showeditmask:(rec.personalNummer == fields.personalNummer),
         nobr:true,
         values:[
            rec.id,
            user.username,
            rec.rechtLOVID
            ],
         hidden:['id']
         )
      }
   /** 
    * Wurde keine Zeile zum 
    * Inline Edit gefunden werden, wird
    * Input Eingabe Bereich angeboten.
    *
    */
   if (showNewInput) {
      out<<taglib.gridEdit (
         editmask:editmask,
         domain:[:],
         showeditmask:true
         )
      }

   %>

</table>
