/**
 * Dieser Controller demonstriert die
 * Verwendung der setDomainField Methode des DAO
 * 
 * Diese Methode ermoeglicht es, Daten in Domain Felder unter
 * Verwendung der Feldvalidatoren zu fuelen.
 * 
 * Moegliche Fehler werden in der Fehlerliste eingetragen.
 * 
 */

package MVC.root.extras.sonstiges

import MVC.domain.JobsDomain


JobsDomain jobs = new JobsDomain(db:db.dbh)

view filename:'erklaerung.tpl'

jobs.clearErrors()
jobs.setDomainField('a123','maxSalary')
jobs.setDomainField('123.45','minSalary')

render 'Inhalt<br />'
render "max Salary: ${jobs.maxSalary}<br />"
render "max Salary: ${jobs.minSalary}<br />"
render '<br />'

render '<h2>Feldfehler</h2>'

jobs.errors.each{error->
   render "Im Feld ${error.field} trat der Fehler: <i>${error.message}</i> auf. Value: ${error.value}<br />"
   }

render '<h2>Satzfehler</h2>'
render jobs.meta.validate()


jobs.clearErrors()

true