/**
 * Controller zur Verwaltung von Benutzerdaten
 * 
 */
package MVC.root.extras.user

import framework.helper.Viewhandler
import MVC.domain.UserDomain

UserDomain user = new UserDomain(
   db:db.dbh
   )

/**
 * Diese Clousre wird vom Gridviewer aufgerufen.
 * 
 * Die Routine ruft nur die Datenbankfunktion
 * "eachDomain" auf und uebergibt die Uebergebene
 * Closure der Datenbakroutine.
 * 
 */
def gridrows = {closure->

  /**
   * Alle Datensaetze
   */
   user.eachDomain(
      '(1=1)',
      'USERNAME',
      closure)
   }


/**
 * Bilde das Objekt
 * und rufe CRUD auf
 */
Viewhandler crud = new Viewhandler(
   controller:this,
   action:'grid',
   domain:user,
   viewBindings:[
      gridrows : gridrows
      ]
   )

   
crud.run()
   