package MVC.taglib

import framework.taglib.Taglib
import groovy.sql.Sql

// ---- Classe ----------------------------------------------------
class Taglib extends Taglib {
// ----------------------------------------------------------------
   //
   // .--update--.
   // -- wann----+-wer+-- was -------------------------------------
   // 13.10.2007 | ny | erstellt
   //            |    |
   //            |    |
   //            |    |

   def request                  // wird vom Template im Kontruktur uebergeben
   def db                       // Datenbankobjekt
   List StandardCGIParameter = ['path','filter']

   Taglib () {
      this.httpMethod = 'POST'
      formAceptCharset = FORM_ACEPT_CHARSET_UTF_8
      }


   // --- Standard Jahresteiler ----------------------------------------
   def jahresteile = {
   // ------------------------------------------------------------------
      // 
      // gibt eine Selectbox mit Standard Jahresteilern aus
      // 
      String tag = '''<select name="jahresteiler">
         <option value="1J">gesamtes Jahr</option>
         <option value="1HJ">1. Halbjahr</option>
         <option value="2HB">2. Habljahr</option>
         <option value="Q1">1. Quartal</option>
         <option value="Q2">2. Quartal</option>
         <option value="Q3">3. Quartal</option>
         <option value="Q4">4. Quartal</option>
         <option value="M1">J&auml;nner</option>
         <option value="M2">Februar</option>
         <option value="M3">M&auml;rz</option>
         <option value="M4">April</option>
         <option value="M5">Mai</option>
         <option value="M6">Juni</option>
         <option value="M"7>Juli</option>
         <option value="M"8>August</option>
         <option value="M9">September</option>
         <option value="M10">Oktober</option>
         <option value="M11">November</option>
         <option value="M12">Dezember</option>
         </select>'''
      return tag
      }

   // --- Selectbox mit Jahreszahlen -----------------------------------
   def jahreswahl = {param->
   // ------------------------------------------------------------------
      // 
      // gibt eine Selectbox mit Jahreszahlen aus
      // 
      // @param   "von"      Beginnend mit Jahr
      // @param   "bis"      endet mit Jahr (wenn 'current' bis aktuellem Jahr)
      // @param   "feldname" Names des Inputfieldes
      // @param   "order"    ::= ASC|DEC auf oder absteigende Reihenfolge
      // @param   "selected" Wenn angegeben, wird das uebergebene Jahr selectiert
      //                     sonst wird das laufende Jahr angenommen
      // 
      // Wird kein Parameter angegeben, so wird von 1991 bis zum aktuellen Jahr + 1
      // erzeugt.
      // 
      // @return  HTML Selectbox mit Jahreszahlen
      // 
      if (param == null) param = [:]

      String fieldname = param.fieldname?:'year'
      Integer endYear = 0
      if (param.get('bis','') == '') {
         endYear = new Date().getYear()+1900
         endYear++ // auch naechstes Jahr
         }
      else {
         switch (param.get('bis','')) {
         case 'current' :
            endYear = new Date().getYear()+1900
            break
         case 'next' :
            endYear = new Date().getYear()+1900
            endYear++
            break
         default:
            endYear = param.get('bis','0').toInteger()
            break
            }
         }

      Integer startYear = param.get('von','1991').toInteger()   // Allgemeines Startjahr
      String tag = """<select name="${fieldname}">\n"""
      Integer curYear = new Date().getYear()+1900

      if (param.get('selected','') != '') { // wurde Jahr selectiert
         curYear = param.get('selected',0).toInteger()
         }
      
      if (param.get('order','ASC') == 'ASC') {
         (startYear..endYear).each {CCYY->
            String sel = ''
            if (CCYY == curYear) sel = ' selected '
            tag += """<option ${sel} value="${CCYY}">${CCYY}</option>\n"""
            }
         }
      else if (param.get('order','') == 'DES') {
         (endYear..startYear).each {CCYY->
            String sel = ''
            if (CCYY == curYear) sel = ' selected '
            tag += """<option ${sel} value="${CCYY}">${CCYY}</option>\n"""
            }}
       else {
         throw new Exception ("tlb:: option order darf nur ASC oder DES enthalten")
         }
      tag += '</select>'
      return tag
      }
   }