// /////////// Basisroutinen fuer Logging ////////////////////
// 
// Stellt die Basisfunktionen fuer logging bereit
// 
// 
// 
// @author:    W. Nagy
// @date:      20.12.2007
// @version:   0.1
// 
// -- wann --+-wer-+-- was ----------------------------------------------
// 20.12.2007| ny  | erstellt
// 21.12.2007| ny  | anpassungen
//           |     | 
//           |     | 
//           |     | 
// 
// 
// 
// 

package framework.helper

import java.io.IOException
import java.util.logging.*
import java.text.SimpleDateFormat

// =====================================================================
public class myFormat extends Formatter {
// =====================================================================

   
   // ------------------------------------------------------------------
  String format(LogRecord rec) {
   // ------------------------------------------------------------------
      // 
      // 
      // 
      // 

      String message = ''
      
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd kk:mm", Locale.GERMAN);
      message =  df.format(new Date())+' - '
      message += rec.getLevel()
      message += ':'

      message += rec.getMessage()

      message += "\n"
      return message.toString();
      }
   }

// =====================================================================
public class Logging {
// =====================================================================
   // 
   // 
   // @param:  request           mein Konstruktur uebergeben
   // 
   // 
   // 
   def request     // muss vom Konstruktor bergeben werden

   static final String base = 'WEB-INF/log'
   static Logger logger
   Handler fLog = null
   
   // --- Erzeugen Logfile ---------------------------------------------
   void createLog(String name,String filename,boolean append) {
   // ------------------------------------------------------------------
      // 
      // @param:  filename          Dateiname 
      //                            Der Pfad wird durch base 
      //                            und logdir bestimmt
      // 
      // 

      logger = Logger.getLogger(name)

      try {
         if (fLog == null)  fLog = new FileHandler(filename,true)  // true = append 
         }
      catch (Exception e) {
         throw new Exception ("Fehler beim erstellen des logfiles OS Message: ${e.message}\n")
         }
      fLog.setFormatter(new myFormat())
      logger.addHandler(fLog)
      }


   // Openmodi
   //
   void openLog(name,filename) {createLoo(name,filename,true)}
   void openLog(name,filename,append) {createLog(name,filename,append)}


   // --- Setzen des Logfiles ------------------------------------------
   void openLog(String name,String filename) {
   // ------------------------------------------------------------------
      // 
      // @param:  filename          Dateiname 
      //                            Der Pfad wird durch base 
      //                            und logdir bestimmt
      // 
      // 

      logger = Logger.getLogger(name)

      try {
         if (fLog == null)  fLog = new FileHandler(filename,true)  // true = append 
         }
      catch (Exception e) {
         throw new Exception ("Fehler beim erstellen des logfiles OS Message: ${e.message}\n")
         }
      fLog.setFormatter(new myFormat())
      logger.addHandler(fLog)
      }


   // --- schreibe Logeintrag-------------------------------------------
   void severe(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.server(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void warning(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.warning(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void info(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.info(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void config(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.config(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void fine(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.fine(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void finer(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.finer(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void finest(String text) {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      this.logger.finest(text)
      }

   // --- schreibe Logeintrag-------------------------------------------
   void closeLog() {
   // ------------------------------------------------------------------
      // 
      // Schreibe Logeintrag als Info
      // 
      // @param:  text        Text des Logeintrags
      // 
      // 
      fLog.close()
      }
   }