// /////////////////////////////////////////////////////////////////
//
// Globale Startroutine der Applikation
//
//
//
//  -- wann --+-wer-+-- was ----------------------------------------------
//  12.10.2007| ny  | estellt
//  21.10.2007| ny  | Datenbankverbindung erstellen
//  11.11.2007| ny  | Unbau auf Startobjekt
//  12.11.2007| ny  | Einbau start.init()
//            |     |
//            |     |
//            |     |
//
import framework.Work
import helper.Zeitmessung
import MVC.authen.CheckUser

import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.LogRecord;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

/**
 * Implementierung des Zugriffslogs
 * 
 * 
 * 
 */ 
private static Logger jlog =  Logger.getLogger("");
private static Logger logger =  Logger.getLogger("");

String root = request?.getRealPath('/')

FileHandler logFileHandler = new FileHandler("${root}WEB-INF/log/mframe_access.log",true)
logFileHandler.setFormatter(new SimpleFormatter())
jlog.addHandler(logFileHandler)

if (request.getSession().getAttribute('user') != null) {
   jlog.log(Level.INFO, "remote: ${request.getRemoteAddr()} user ${request.getSession().getAttribute('user')} path:${request.getParameter('path')} QueryString: ${request.getQueryString()}")
   }

Zeitmessung stoppuhr = new Zeitmessung()
stoppuhr.start()


String computer = System.getenv()['COMPUTERNAME']
// Erkenne Tunte
//
if (computer == null) {
   computer = System.getenv()['HOME']
   }

String environment = 'produktion'
String info = '** unknwon **'
String servername='localhost'

/** 
 * Pruefen auf welcher Maschine das
 * System l?uft und setzen der Umgebung
 * fuer mframe 
 */

switch (computer) {

   case 'NY07' :
      environment = 'develop'
      info = 'TEST-NY07'
      break

   default :
      environment = 'default'
      info = 'default'
      break
   }

try {
   Work app = new Work(
         request:request,
         response:response,
         environment:environment,
         servername:servername,
         stoppuhr:stoppuhr,
         applicationversion:'1.80-R020',
         logger:Logger.getLogger("")
         )


   app.init()

   String output = app.run()
   if (output != null) out << output
   }
catch(Exception e) {
   out << '<div style="border:3px ridge gray;font-family:Arial,sans-serif;padding:8px;background-color:#FFD9D7">'
   out << '<h1 style="font-size:12pt">Unerwartetes Ereignis</h1>'
   out << 'Das System meldet:<br>'
   out << '<div style="border:1px solid black;font-family:Courier;background-color:white">'
   out << e.message
   logger.severe(e.message)
   out << '</div>'
   out << '<p/>'
   out << 'Bitte kopieren sie diese Seite und senden diese an den Applikationsentwickler<p>'
   out << '<a href="/">Neu starten</a><p>'
   out << """path: "${request.getParameter('path')}" <br>"""
   out << """Zeitpunkt: "${new Date()}" <br>"""
   out << """Computer: "${computer}" <br>"""
   out << """Server: "${servername}" <br>"""
   out << """Environment: "${environment}" <br>"""
   out << '</div>'
   }



logFileHandler.flush()
logFileHandler.close()

// -- LAST LINE --